
local http = require( "socket.http" );
local lastRequest = nil;

function GetPage( url )
    return http.request( url );
end--GetPage( url )

local battlegroups = {
    ["ko"] = {
    	BGBattleGroups = {
    		["격노의 전장"] = "1",
    		["징벌의 전장"] = "2",
    		["야성의 전장"] = "3",
    	},
    	BGServerBattleGroup = {
    		["가로나"] = "1",
    		["굴단"] = "2",
    		["노르간논"] = "2",
    		["달라란"] = "1",
    		["데스윙"] = "3",
    		["듀로탄"] = "2",
    		["라그나로스"] = "1",
    		["레인"] = "3",
    		["렉사르"] = "3",
    		["말리고스"] = "2",
    		["말퓨리온"] = "1",
    		["메디브"] = "2",
    		["메카나르"] = "4",
    		["불타는 군단"] = "1",
    		["블랙무어"] = "3",
    		["세나리우스"] = "3",
    		["스톰레이지"] = "3",
    		["신록의 정원"] = "4",
    		["아즈샤라"] = "2",
    		["알라르"] = "2",
    		["알레리아"] = "2",
    		["알렉스트라자"] = "1",
    		["알카트라즈"] = "4",
    		["에이그윈"] = "2",
    		["엘룬"] = "3",
    		["와일드해머"] = "3",
    		["우서"] = "1",
    		["윈드러너"] = "2",
    		["이오나"] = "3",
    		["줄진"] = "3",
    		["카라잔"] = "3",
    		["카르가스"] = "1",
    		["쿨 티라스"] = "3",
    		["티리온"] = "1",
    		["폭풍우 요새"] = "4",
    		["하이잘"] = "3",
    		["헬스크림"] = "1",
    	},
    	BGServerType = {
    		["가로나"] = "PvP",
    		["굴단"] = "PvP",
    		["노르간논"] = "PvP",
    		["달라란"] = "PvP",
    		["데스윙"] = "PvP",
    		["듀로탄"] = "PvP",
    		["라그나로스"] = "PvP",
    		["레인"] = "PvP",
    		["렉사르"] = "Normal",
    		["말리고스"] = "PvP",
    		["말퓨리온"] = "PvP",
    		["메디브"] = "PvP",
    		["메카나르"] = "PvP",
    		["불타는 군단"] = "Normal",
    		["블랙무어"] = "PvP",
    		["세나리우스"] = "PvP",
    		["스톰레이지"] = "Normal",
    		["신록의 정원"] = "PvP",
    		["아즈샤라"] = "PvP",
    		["알라르"] = "PvP",
    		["알레리아"] = "PvP",
    		["알렉스트라자"] = "PvP",
    		["알카트라즈"] = "PvP",
    		["에이그윈"] = "PvP",
    		["엘룬"] = "PvP",
    		["와일드해머"] = "Normal",
    		["우서"] = "PvP",
    		["윈드러너"] = "Normal",
    		["이오나"] = "PvP",
    		["줄진"] = "PvP",
    		["카라잔"] = "PvP",
    		["카르가스"] = "PvP",
    		["쿨 티라스"] = "PvP",
    		["티리온"] = "PvP",
    		["폭풍우 요새"] = "PvP",
    		["하이잘"] = "PvP",
    		["헬스크림"] = "PvP",
    	},
    },
    ["tw"] = {
    	BGBattleGroups = {
    		["嗜血"] = "1",
    		["暴怒"] = "2",
    	},
    	BGServerBattleGroup = {
    		["霜之哀傷"] = "2",
    		["諾姆瑞根"] = "2",
    		["戰歌"] = "1",
    		["血頂部族"] = "1",
    		["寒冰皇冠"] = "2",
    		["阿薩斯"] = "2",
    		["眾星之子"] = "2",
    		["銀翼要塞"] = "2",
    		["憤怒使者"] = "2",
    		["聖光之願"] = "2",
    		["夜空之歌"] = "2",
    		["暴風祭壇"] = "2",
    		["血之谷"] = "2",
    		["亞雷戈斯"] = "2",
    		["語風"] = "2",
    		["奧妮克希亞"] = "2",
    		["鬼霧峰"] = "2",
    		["屠魔山谷"] = "2",
    		["米奈希爾"] = "1",
    		["冰風崗哨"] = "1",
    		["狂熱之刃"] = "1",
    		["巴納札爾"] = "1",
    		["水晶之刺"] = "1",
    		["天空之牆"] = "1",
    		["世界之樹"] = "1",
    		["雷鱗"] = "1",
    		["巨龍之喉"] = "1",
    		["冰霜之刺"] = "1",
    		["日落沼澤"] = "1",
    		["地獄吼"] = "1",
    		["暗影之月"] = "1",
    		["尖石"] = "1",
    	},
    	BGServerType = {
    		["霜之哀傷"] = "PvP",
    		["諾姆瑞根"] = "PvP",
    		["戰歌"] = "PvP",
    		["血頂部族"] = "PvP",
    		["寒冰皇冠"] = "PvP",
    		["阿薩斯"] = "PvP",
    		["眾星之子"] = "Normal",
    		["銀翼要塞"] = "PvP",
    		["憤怒使者"] = "PvP",
    		["聖光之願"] = "Normal",
    		["夜空之歌"] = "PvP",
    		["暴風祭壇"] = "Normal",
    		["血之谷"] = "PvP",
    		["亞雷戈斯"] = "Normal",
    		["語風"] = "Normal",
    		["奧妮克希亞"] = "Normal",
    		["鬼霧峰"] = "PvP",
    		["屠魔山谷"] = "PvP",
    		["米奈希爾"] = "PvP",
    		["冰風崗哨"] = "PvP",
    		["狂熱之刃"] = "PvP",
    		["巴納札爾"] = "Normal",
    		["水晶之刺"] = "PvP",
    		["天空之牆"] = "Normal",
    		["世界之樹"] = "Normal",
    		["雷鱗"] = "PvP",
    		["巨龍之喉"] = "PvP",
    		["冰霜之刺"] = "PvP",
    		["日落沼澤"] = "PvP",
    		["地獄吼"] = "PvP",
    		["暗影之月"] = "Normal",
    		["尖石"] = "PvP",
    	},
    },
};

function SaveList( file, list, level, ignorelevel )
    local spacing = "";

    for i = 1, level do
        spacing = spacing .. "    ";
    end--for
    for i, v in pairs( list ) do
        if( type( v ) == "table" ) then
            file:write( ("%s%s = {\n"):format( spacing, ( level == 1 ) and ( "Glory." .. i ) or i ) );
            SaveList( file, v, level + 1 );
            file:write( ("%s}\n"):format( spacing ) );
        elseif( not ignorelevel ) then
            file:write( ("%s[%q] = %q,\n"):format( spacing, i, v ) );
        end--if
    end--for
end--SaveList( file, list )

function ProcessBattlegroupList( url, dest, counter )
    local page = GetPage( url );

    if( page ) then
        for realm, type in page:gmatch( "<a class=\"link\" href=\".-\"> (.-)</a></td><td class=\"NewTableCell\">(.-)</td>" ) do
            dest.BGServerBattleGroup[realm] = counter;
            dest.BGServerType[realm] = type;
        end--for
    end--if
end--ProcessBattlegroupList( url, dest )

local page = GetPage( "http://www.realmhistory.net/battlegroups.html" );

if( page ) then
    for type, substring in page:gmatch( "<table style=\"width:206px;\"><tr><td class=\"NewTableHeader\"><span class=\"desc_orange\" style=\"font%-weight:normal;\">(%u%u).-</span><td/></tr><tr>(.-)</table>" ) do
        local locale = battlegroups[type:lower()];

        if( not locale ) then
            battlegroups[type:lower()] = { counter = 1, BGBattleGroups = {}, BGServerBattleGroup = {}, BGServerType = {}, };
            locale = battlegroups[type:lower()];
        end--if
        for pagename, name in substring:gmatch( "<td class=\"NewTableCell\"><span class=\"desc_orange\">></span><a class=\"link\" href=\"(.-)\"> (.-)</a></td></tr>" ) do
            locale.BGBattleGroups[name] = locale.counter;
            ProcessBattlegroupList( pagename, locale, locale.counter );
            locale.counter = locale.counter + 1;
        end--for
    end--for
end--if

local hFile = io.open( "RealmList.lua", "w+" );

if( hFile == nil ) then
    return;
end--if

hFile:write( "\nlocal Glory = LibStub:GetLibrary( \"LibLordFarlander-Glory-3.0\", true )\n" );
hFile:write( "if( not Glory ) then return end\n\n" );

for locale, battlegrouplist in pairs( battlegroups ) do
    hFile:write( ("if GetCVar(\"realmList\"):match(\"%s\") then\n"):format( locale ) );
    SaveList( hFile, battlegrouplist, 1, true );
    hFile:write( "end\n" );
end--for

hFile:write( "\nif( not Glory.BGServerBattleGroup ) then\n" );
hFile:write( "    Glory.BGServerBattleGroup = {}\n" );
hFile:write( "    Glory.BGServerType = {}\n" );
hFile:write( "    Glory.BGBattleGroups = {}\n" );
hFile:write( "end\n\n" );

hFile:close();